<?php
class ControllerPaymentvads extends Controller {
	private $error = array(); 
	
	public function index() {
		
		$this->load->language('payment/vads');
		
		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			if (isset($this->request->post['vads_available_languages']) && !empty($this->request->post['vads_available_languages']))
			{ $this->request->post['vads_available_languages'] = implode(';', $this->request->post['vads_available_languages']);
			}else $this->request->post['vads_available_languages'] = '';
			
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSetting('vads', $this->request->post);				
			$this->session->data['success'] = $this->language->get('text_success');
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		
		$this->data['vads_languages'] = array( 'fr' => $this->language->get('FRENCH'),
									 		   'de' => $this->language->get('DUTCH'),
										 	   'en' => $this->language->get('ENGLISH'),
										 	   'es' => $this->language->get('SPANISH'),
										 	   'zh' => $this->language->get('CHINESE'),
										 	   'it' => $this->language->get('ITALIAN'),
										 	   'ja' => $this->language->get('JAPANESE'),
										 	   'pt' => $this->language->get('PORTUGUESE')
											  );
		$this->data['validation_mode'] = array( 'df' => $this->language->get('DEFAULT'),
									 		    'au' => $this->language->get('AUTOMATIC'),
										 		'ma' => $this->language->get('MANUAL')
											   );									  
		$this->data['redirect_enabled'] = array( 'yes' => $this->language->get('YES'),
									 		     'no' => $this->language->get('NO')
											   );	

		$this->data['VADS_MODULE_INFO'] = $this->language->get('VADS_MODULE_INFO');									   
        $this->data['VADS_DEVELOPED_BY'] = $this->language->get('VADS_DEVELOPED_BY');
        $this->data['VADS_CONTACT_EMAIL'] = $this->language->get('VADS_CONTACT_EMAIL');
        $this->data['VADS_CONTRIB_VERSION'] = $this->language->get('VADS_CONTRIB_VERSION');
        $this->data['VADS_GATEWAY_VERSION'] = $this->language->get('VADS_GATEWAY_VERSION');
        $this->data['VADS_CMS_VERSION'] = $this->language->get('VADS_CMS_VERSION');		
		
        $this->data['VADS_PAYMENT_ACCESS']= $this->language->get('VADS_PAYMENT_ACCESS');
        $this->data['VADS_PAYMENT_PAGE']= $this->language->get('VADS_PAYMENT_PAGE');
        $this->data['VADS_AMOUNT_RESTRICTIONS']= $this->language->get('VADS_AMOUNT_RESTRICTIONS');
        $this->data['VADS_RETURN_TO_SHOP']= $this->language->get('VADS_RETURN_TO_SHOP');
        $this->data['VADS_MODULE_SETTING']= $this->language->get('VADS_MODULE_SETTING');
		$this->data['VADS_GATEWAY_URL'] = $this->language->get('VADS_GATEWAY_URL');
		$this->data['VADS_SITE_ID'] = $this->language->get('VADS_SITE_ID');
		$this->data['VADS_KEY_TEST'] = $this->language->get('VADS_KEY_TEST');
		$this->data['VADS_KEY_PROD'] = $this->language->get('VADS_KEY_PROD');
		$this->data['VADS_CTX_MODE'] = $this->language->get('VADS_CTX_MODE');
		$this->data['VADS_LANGUAGE'] = $this->language->get('VADS_LANGUAGE');
		
		$this->data['VADS_AVAILABLE_LANGUAGES'] = $this->language->get('VADS_AVAILABLE_LANGUAGES');
		
		$this->data['VADS_PAYMENT_CARDS'] = $this->language->get('VADS_PAYMENT_CARDS');
		$this->data['VADS_MINIMUM_AMOUNT'] = $this->language->get('VADS_MINIMUM_AMOUNT');
 		$this->data['VADS_MAXIMUM_AMOUNT'] = $this->language->get('VADS_MAXIMUM_AMOUNT');
 		
 		$this->data['VADS_CAPTURE_DELAY'] = $this->language->get('VADS_CAPTURE_DELAY');
 		$this->data['VADS_VALIDATION_MODE'] = $this->language->get('VADS_VALIDATION_MODE');
 		$this->data['VADS_REDIRECT_ENABLED'] = $this->language->get('VADS_REDIRECT_ENABLED');
 		
 		$this->data['VADS_REDIRECT_SUCCESS_TIMEOUT'] = $this->language->get('VADS_REDIRECT_SUCCESS_TIMEOUT');
 		$this->data['VADS_REDIRECT_SUCCESS_MESSAGE'] = $this->language->get('VADS_REDIRECT_SUCCESS_MESSAGE');
 		$this->data['VADS_REDIRECT_ERROR_TIMEOUT'] = $this->language->get('VADS_REDIRECT_ERROR_TIMEOUT');
 		$this->data['VADS_REDIRECT_ERROR_MESSAGE'] = $this->language->get('VADS_REDIRECT_ERROR_MESSAGE');
 		$this->data['VADS_URL_ERROR'] = $this->language->get('VADS_URL_ERROR');
 		$this->data['VADS_RETURN_MODE'] = $this->language->get('VADS_RETURN_MODE');
 		$this->data['VADS_URL_SUCCESS'] = $this->language->get('VADS_URL_SUCCESS');
 		
 		$this->data['VADS_URL_CHECK'] = $this->language->get('VADS_URL_CHECK');
		$this->data['entry_order_status_failed'] = $this->language->get('entry_order_status_failed');	
		$this->data['entry_order_status_succes'] = $this->language->get('entry_order_status_succes');	
		
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_mb_id'] = $this->language->get('entry_mb_id');
		$this->data['entry_custnote'] = $this->language->get('entry_custnote');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		
		$this->data['tab_general'] = $this->language->get('tab_general');
		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
  		$this->document->breadcrumbs = array();
   		$this->document->breadcrumbs[] = array( 'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
								       			'text'      => $this->language->get('text_home'),
								      			'separator' => FALSE
   											   );
   		$this->document->breadcrumbs[] = array( 'href'      => HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'],
									       		'text'      => $this->language->get('text_payment'),
									      		'separator' => ' :: '
									   		   );
		
   		$this->document->breadcrumbs[] = array( 'href'      => HTTPS_SERVER . 'index.php?route=payment/vads&token=' . $this->session->data['token'],
									       		'text'      => $this->language->get('heading_title'),
									      		'separator' => ' :: '
									   		   );
				
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=payment/vads&token=' . $this->session->data['token'];
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];
		
			
			
			$this->data['vads_site_id'] = $this->config->get('vads_site_id');
			$this->data['vads_key_test'] = $this->config->get('vads_key_test');
			$this->data['vads_key_prod'] = $this->config->get('vads_key_prod');
			$this->data['vads_ctx_mode'] = $this->config->get('vads_ctx_mode');
			$this->data['vads_gateway_url'] = $this->config->get('vads_gateway_url');
			
			$this->data['vads_language'] = $this->config->get('vads_language');
			$this->data['vads_available_languages'] = explode(';', $this->config->get('vads_available_languages'));
		
			$this->data['vads_capture_delay'] = $this->config->get('vads_capture_delay');
			$this->data['vads_payment_cards'] = $this->config->get('vads_payment_cards');
			
			$this->data['vads_minimum_amount'] = $this->config->get('vads_minimum_amount');
			$this->data['vads_maximum_amount'] = $this->config->get('vads_maximum_amount');
			
			$this->data['vads_validation_mode'] = $this->config->get('vads_validation_mode');
			$this->data['vads_redirect_enabled'] = $this->config->get('vads_redirect_enabled');
			$this->data['vads_redirect_success_timeout'] = $this->config->get('vads_redirect_success_timeout');
			$this->data['vads_redirect_success_message'] = $this->config->get('vads_redirect_success_message');
			$this->data['vads_redirect_error_timeout'] = $this->config->get('vads_redirect_error_timeout');
			$this->data['vads_redirect_error_message'] = $this->config->get('vads_redirect_error_message');
			$this->data['vads_return_mode'] = $this->config->get('vads_return_mode');
			$this->data['vads_url_error'] = $this->config->get('vads_url_error');
			$this->data['vads_url_success'] = $this->config->get('vads_url_success');
			$this->data['vads_order_status_failed_id'] = $this->config->get('vads_order_status_failed_id');
			$this->data['vads_order_status_succes_id'] = $this->config->get('vads_order_status_succes_id');

			
			
			
		$this->load->model('localisation/order_status');
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		if (isset($this->request->post['vads_geo_zone_id'])) {
			$this->data['vads_geo_zone_id'] = $this->request->post['vads_geo_zone_id'];
		} else {
			$this->data['vads_geo_zone_id'] = $this->config->get('vads_geo_zone_id'); 
		} 	
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		$this->data['vads_status'] = $this->config->get('vads_status');
		$this->data['vads_sort_order'] = $this->config->get('vads_sort_order');
		$this->data['vads_rid'] = $this->config->get('vads_rid');
		
		if (isset($this->request->post['vads_custnote'])) {
			$this->data['vads_custnote'] = $this->request->post['vads_custnote'];
		} else {
			$this->data['vads_custnote'] = $this->config->get('vads_custnote');
		}
		$this->template = 'payment/vads.tpl';
		$this->children = array(
								'common/header',	
								'common/footer'	
							    );
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/vads')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
	
	public function install() {
	$this->load->language('payment/vads');
		$this->data['vads_gateway_url'] = 'https://secure.payzen.eu/vads-payment/';
		$this->data['vads_site_id'] = '12345678';
		$this->data['vads_key_test'] = '1111111111111111'; 
		$this->data['vads_key_prod'] = '2222222222222222';
		$this->data['vads_ctx_mode'] = 'TEST';
		$this->data['vads_language'] = 'fr';
		$this->data['vads_payment_cards'] = '';
 		$this->data['vads_capture_delay'] = '';
 		$this->data['vads_validation_mode'] = '';
 		$this->data['vads_redirect_enabled'] = 0;
 		
		
 		
 		$this->data['vads_redirect_success_timeout'] = '5';
 		$this->data['vads_redirect_success_message'] = $this->language->get('VADS_DEFAULT_SUCCESS_MSG');
 		$this->data['vads_redirect_error_timeout'] = '5';
 		$this->data['vads_redirect_error_message'] = $this->language->get('VADS_DEFAULT_ERROR_MSG');
 		$this->data['vads_url_error'] = HTTP_CATALOG . 'index.php?route=checkout/cart';
 		$this->data['vads_return_mode'] = 'GET';
 		$this->data['vads_url_success'] = HTTP_CATALOG . 'index.php?route=checkout/success';
 		
 		$this->data['vads_order_status_failed_id'] = '10';
 		$this->data['vads_order_status_succes_id']='5';
 		$this->data['vads_geo_zone_id']='0';
 		
		$this->data['vads_status']='1';
		$this->data['vads_sort_order']='1';
		
		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('vads', $this->data);				
		$this->session->data['success'] = $this->language->get('text_success');
		
		$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
	}
	
}
?>